# Swag Shop

An e-commerence multitenant shop app.

## Core idea
This app provides a dashboard for managing individual shop data like products and similar things. Then it's up to the tenant to craft their own frontend and make use of the API.

## Running
### Backend
1. Dependencies
Straight forward, you need to install dependencies via *[uv](https://docs.astral.sh/uv/)*

```
cd backend
uv sync
```

2. Fill out `.env`
You can use `.env.example` as a reference

3. Run it!
```
fastapi dev backend/app/main.py
```

### Frontend
1. Dependencies
Using npm (or your favorite package manager)
```
cd frontend
npm install
```

2. Fill out `.env`
As with backend, there is `.env.example`

3. Run it!
There is a dev package script
```
npm run dev
```
<br>

- For deployment a `docker-compose.yml` is provided

## Tech Stack
- **PostgreSQL**
- **Backend** - *FastAPI* + *SQLModel*
- **Frontend** - *Vite* + *Typescript* + *ShadcnUI* + *Tanstack Query*

## Future plans

- True API integration
- Audit log
- Stripe integration